;	"PONG.ASM" by Jakub Husak on 2012-12-12
;
;	Source merged from last known source and final $150 bytes executable by JAC! on 2013-01-07
;	Make compatible and squeezed into $13f bytes by JAC! on 2013-01-07

	.macro m_info
	.print ":1: " , :1, " - ", :1 + .len :1 -1, " (", .len :1,")"
	.endm

	icl "ATARI.ASM"


leftpad		= game.positions+$0
rightpad	= game.positions+$1
ball_y		= game.positions+$2
ball_x		= game.positions+$3

leftpad2	= $70
rightpad2	= $71
;graf		= $db76		;Contains $00 $f9 $e0 $00

;	net_plr_pos = hposp0
;	net_plr_col = colpm0
	net_plr_grf = grafp0
;	right_plr_pos = hposp1
	right_plr_grf = grafp1
;	left_plr_pos = hposp2
	left_plr_grf = grafp2
	ball_xpos = hposp3
	ball_col = p3pl
	ball_grf = grafp3
	top_band = 27
	bottom_band = 103

	org $80

	.proc game
	bvc start		;<V>=0 when started from DOS

	.local positions
	.byte $80,$c4,$34,$44
	.byte $a8
	.endl

	.local digits

	.local offsets
	.byte digdef.d0-digdef,digdef.d1-digdef,digdef.d2-digdef,digdef.d3-digdef,digdef.d4-digdef,digdef.d5-digdef
	.byte digdef.d6-digdef,digdef.d7-digdef,digdef.d8-digdef,digdef.d9-digdef
	.endl

	.local digdef
d5	.byte %11111111
	.byte %11100000
d3	.byte %11111111
	.byte %00000111
d2	.byte %11111111
	.byte %00000111
d6	.byte %11111111
	.byte %11100000
d8	.byte %11111111
	.byte %11100111
d9	.byte %11111111
	.byte %11100111
	.byte %11111111
	.byte %00000111
d0	.byte %11111111
	.byte %11100111
d4	.byte %11100111
	.byte %11100111
d7	.byte %11111111
d1	.byte %00000111
	.byte %00000111
	.byte %00000111
	.byte %00000111
	.byte %00000111
	.endl

	m_info offsets
	m_info digdef
	m_info digits
	.endl

	.local incdec
	.byte $c6,$e6
	.endl

start	sei
	ldx #4		;#4 is only for audc1
init	lda positions,x
	sta hposp0,x
	sta colpm0,x
	sta audc1-4,x
	dex
	bpl init

	.proc main_loop
	lda #$e			;Top of screen
	jsr wait_for_line

	jsr clear_grafp
	sta dmactl

	.proc draw_digits
digit_left = *+1
	ldx digits.offsets
digit_right = *+1
	ldy digits.offsets

loop	jsr draw_digit_line
	cmp #$18
	bcc loop
	.endp

	jsr clear_grafp
	jsr horizontal_line

	.proc field
;	lda vcount
	.byte $af,a(vcount)	;LAX abs
	cmp #bottom_band+2
	beq lastline

	and #2
	beq *+4
	lda #$e0

	sta wsync
	sta net_plr_grf

	txa			;Old VCount
	ldy #$1c
	jsr draw_pads_and_ball
	ldy #0
	sty audf1
	sec
	sbc #2
	sta wsync
	jsr draw_ball
	sec
	sbc #10
	jsr draw_pads_and_ball
	jmp field

lastline
	.endp
	
	jsr horizontal_line.no_wait
	sta ball_grf

	.proc bounce_top_and_border
	lda ball_y
	cmp #top_band
	bcc chgy
	cmp #bottom_band
	bcc skip
chgy	sta audf1
	lda skip
	eor #$20
	sta skip
skip	inc ball_y
	.endp

	.proc bounce_pads_and_goal
	lda ball_col ; 1 - right; 2  - left
	lsr
	tax
	beq not_hit_pad
	lda incdec-1,x	;$c624 =>[$3b] $c6 $e6
	sta not_hit_pad
	sta audf1
not_hit_pad
	inc ball_x
	bne not_ball_out
	lda not_hit_pad
	cmp #$c6
	bne not_right
	ldx #draw_digits.digit_right-draw_digits.digit_left
not_right
	inc draw_digits.digit_right,x
not_ball_out
	.endp

	.proc read_controllers
	ldx #1
	ldy porta
chgpads
	tya
	lsr 
	scc:inc leftpad,x
	lsr
	scc:dec leftpad,x
	lsr
	lsr
	tay
	lda leftpad,x
	and #$3f
	sta leftpad,x
;	clc		;<C>=1 if not left/right is pressed
	adc #27
	sta leftpad2,x
	dex
	bpl chgpads
	.endp

	lda ball_x
	sta ball_xpos
	sta hitclr
	jmp main_loop

	.endp

	m_info main_loop

	.proc horizontal_line
	jsr wait_3_lines
no_wait	lda #$0f
	sta colbk
	jsr wait_3_lines
	lda #$00
	sta colbk
	rts
	.endp

	.proc clear_grafp	;OUT: <A>=0
	ldy #3
	lda #0
loop	sta grafp0,y
	dey
	bpl loop
	rts
	.endp

draw_digit_line
	lda digits.digdef,x
	sta right_plr_grf
	lda digits.digdef,y
	sta left_plr_grf
	inx
	iny

wait_3_lines
	lda #2
	clc
	adc vcount
wait_for_line
	cmp vcount
	bne wait_for_line
	rts

draw_pads_and_ball
	cmp leftpad2
	sne:sty right_plr_grf
	cmp rightpad2
	sne:sty left_plr_grf
draw_ball
	cmp ball_y
	sne:sty ball_grf
	rts

	.endp		;end of game

.print "Total code size ", .len game

